Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/intelligence/SelectionMonitor.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/intelligence/SelectionMonitor.java	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/intelligence/SelectionMonitor.java	(revision 15582)
@@ -6,4 +6,6 @@
 import org.openstreetmap.josm.data.osm.OsmPrimitive;
 import org.openstreetmap.josm.plugins.czechaddress.NotNullList;
+import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.House;
+import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.Street;
 
 /**
@@ -37,7 +39,9 @@
             r.openTransaction();
             for (OsmPrimitive selectedPrim :newSelection)
-                r.consider(selectedPrim);
+                if (House.isMatchable(selectedPrim) || Street.isMatchable(selectedPrim))
+                    r.update(selectedPrim);
             for (OsmPrimitive selectedPrim :lastSelection)
-                r.consider(selectedPrim);
+                if (House.isMatchable(selectedPrim) || Street.isMatchable(selectedPrim))
+                    r.update(selectedPrim);
             r.closeTransaction();
         }
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/parser/DatabaseParser.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/parser/DatabaseParser.java	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/parser/DatabaseParser.java	(revision 15582)
@@ -108,5 +108,5 @@
 
             int total = 0, count;
-            byte[] buffer = new byte[1024*128];
+            byte[] buffer = new byte[1024*512];
             while ((count = con.getInputStream().read(buffer)) >= 0) {
                 bos.write(buffer, 0, count);
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/parser/MvcrParser.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/parser/MvcrParser.java	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/parser/MvcrParser.java	(revision 15582)
@@ -44,6 +44,11 @@
 
             // If the region filter is on, apply it!
-            if (filRegion != null && !attributes.getValue("nazev").equals(filRegion))
-                return;
+            if (filRegion != null && !attributes.getValue("nazev").equals(filRegion)) {
+                curRegion = null;
+                curViToCi = null;
+                curSuburb = null;
+                curStreet = null;
+                return;
+            }
 
             /*curRegion = target.findRegion(
@@ -70,6 +75,10 @@
 
             // If the viToCi filter is on, apply it!
-            if (filViToCi != null && !attributes.getValue("nazev").equals(filViToCi))
-                return;
+            if (filViToCi != null && !attributes.getValue("nazev").equals(filViToCi)) {
+                curViToCi = null;
+                curSuburb = null;
+                curStreet = null;
+                return;
+            }
 
             //curViToCi = curRegion.findViToCi(attributes.getValue("nazev"));
@@ -87,6 +96,9 @@
 
             // If the suburb filter is on, apply it!
-            if (filSuburb != null && !attributes.getValue("nazev").equals(filSuburb))
-                return;
+            if (filSuburb != null && !attributes.getValue("nazev").equals(filSuburb)) {
+                curSuburb = null;
+                curStreet = null;
+                return;
+            }
 
             //curSuburb = curViToCi.findSuburb(attributes.getValue("nazev"));
@@ -102,6 +114,8 @@
 
             // If the street filter is on, apply it!
-            if (filStreet != null && !attributes.getValue("nazev").equals(filStreet))
-                return;
+            if (filStreet != null && !attributes.getValue("nazev").equals(filStreet)) {
+                curStreet = null;
+                return;
+            }
 
             ElementWithStreets   topElem = curSuburb;
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/proposal/ProposalContainer.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/proposal/ProposalContainer.java	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/proposal/ProposalContainer.java	(revision 15582)
@@ -9,4 +9,5 @@
 import javax.swing.event.ListDataListener;
 import org.openstreetmap.josm.data.osm.OsmPrimitive;
+import org.openstreetmap.josm.plugins.czechaddress.PrimUtils;
 
 /**
@@ -22,5 +23,5 @@
  * @see Proposal
  */
-public class ProposalContainer implements ListModel {
+public class ProposalContainer implements ListModel, Comparable<ProposalContainer> {
 
 
@@ -216,3 +217,7 @@
     }
 
+    public int compareTo(ProposalContainer o) {
+        return PrimUtils.comparator.compare(this.target, o.target);
+    }
+
 }
